/* Tabela FUNLAYOUTIMP: TABELA DE FUNES DO LAYOUT DE IMPORTAO*/
/* Descrio: A trigger insere registros na tabela LOGOPERAVND a partir de alteraes na tabela FUNLAYOUTIMP */
/* Objetivo: Gerar um log que vai registrar as alteraes na FUNLAYOUTIMP,
             utilizando a tabela de Logs de Operaes do VND*/
CREATE OR REPLACE TRIGGER LOG_VND_FUNLAYOUTIMP
AFTER DELETE OR INSERT OR UPDATE
ON FUNLAYOUTIMP FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_IDTIPOOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF UPDATING THEN
		IF NVL(:NEW.CDLAYOUTIMP,'NULL') <> NVL(:OLD.CDLAYOUTIMP,'NULL') THEN
	 	    V_DESC := 'Cd Layout Imp ' || '' || NVL(:NEW.CDLAYOUTIMP,'');
		END IF;
		IF NVL(:NEW.NRSEQTABELAY,'NULL') <> NVL(:OLD.NRSEQTABELAY,'NULL') THEN
	            V_DESC := NVL(V_DESC,'') || ' ' ||'Nr Seq da Tabela ' || '' || NVL(:NEW.NRSEQTABELAY,'');
		END IF;
		IF NVL(:NEW.IDFUNARQLAY,'NULL') <> NVL(:OLD.IDFUNARQLAY,'NULL') THEN
	            V_DESC := NVL(V_DESC,'') || ' ' ||'Id Funo Oper ' || '' || NVL(:NEW.IDFUNARQLAY,'');
		END IF;
		IF NVL(:NEW.IDINACONSARQIMP,'NULL') <> NVL(:OLD.IDINACONSARQIMP,'NULL') THEN
        	    V_DESC := NVL(V_DESC,'') || ' ' ||'Id Ina Consumidor ' || '' || NVL(:NEW.IDINACONSARQIMP,'');
		END IF;

      V_ITPESQ := :NEW.CDLAYOUTIMP||:NEW.NRSEQTABELAY||:NEW.IDFUNARQLAY;
      V_IDTIPOOPER := '2';
   ELSE
      IF INSERTING THEN
      V_DESC   := 'Cd Layout Imp '       || '' || NVL(:NEW.CDLAYOUTIMP,'' )   || ' ' ||
                  'Nr Seq da Tabela '    || '' || NVL(:NEW.NRSEQTABELAY,'')   || ' ' ||
                  'Id Funo Oper '      || '' || NVL(:NEW.IDFUNARQLAY,'' )   || ' ' ||
                  'Id Ina Consumidor'    || '' || NVL(:NEW.IDINACONSARQIMP,'' );
      V_ITPESQ := :NEW.CDLAYOUTIMP||:NEW.NRSEQTABELAY||:NEW.IDFUNARQLAY;
         V_IDTIPOOPER := '1';
      ELSE
         IF DELETING THEN
      V_DESC   := 'Cd Layout Imp '       || '' || NVL(:OLD.CDLAYOUTIMP,'' )   || ' ' ||
                  'Nr Seq da Tabela '    || '' || NVL(:OLD.NRSEQTABELAY,'')   || ' ' ||
                  'Id Funo Oper '      || '' || NVL(:OLD.IDFUNARQLAY,'' )   || ' ' ||
                  'Id Ina Consumidor'    || '' || NVL(:OLD.IDINACONSARQIMP,'' );
      V_ITPESQ := :OLD.CDLAYOUTIMP||:OLD.NRSEQTABELAY||:OLD.IDFUNARQLAY;
            V_IDTIPOOPER := '3';
         END IF;
      END IF;
   END IF;
   V_DESC := SUBSTR(V_DESC, 1, 300);
   INSERT INTO LOGOPERAVND
      (NMTABELAVND,
       DTOPERACAOVND,
       NMRESPOPERVND,
       IDTIPOOPERVND,
       DSOPERACAOVND,
       CDPESQITEMVND,
       DSRDMUSUOPERVND,
       DSENDUSUOPERVND,
       DSNMUSUOPERVND,
       DSMETUSUOPERVND,
       CDORESPOPERVND)
   VALUES
      ('FUNLAYOUTIMP',
       SYSDATE,
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       NVL(V_DESC,' '),
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_VND_FUNLAYOUTIMP','5.20.001'); END;
/


