function ReplicaoDeDocumentos() {
	const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
	const z = new ZeedhiAPIConstructor(browser, protractor);
	const Helper = require('teknisa-helper');
	const geral = new Helper.geral();
	const protractorHelper = require('protractor-helper');

	this.abrir = () => {
		z.component.menu.open();
		protractorHelper.waitForElementVisibility(element(by.css('.menu-overlay')));
		z.component.menu.clickByPath(['Parametrização', 'Documentos Fiscais',
			'Replicação de Documentos']);
		geral.esperarLoading();
	};

	this.adicionar = (codigo, es, tipoOperacao, descricao, atualizaAutomaticamente) => {
		geral.clickAndFllField('NRREPLICDOC', codigo);
		geral.clickAndFllField('DSREPLICDOC', descricao);
		geral.selectNative('IDENTRSAIDOP', atualizaAutomaticamente);
		geral.selectNative('IDENTRSAIDOP', es);
		geral.searchAndClickGridField('NMTIPOOPER', tipoOperacao, 'NMTIPOOPER');
	};

	this.adicionarDocumentoGerado = (unidadeOrigem, unidadeDestino, es, serie, tipoOperacao,
		descricao) => {
		geral.searchAndClickGridField('NMFILIORIG', unidadeOrigem, 'NMFILIAL');
		geral.searchAndClickGridField('NMFILIDEST', unidadeDestino, 'NMFILIAL');
		geral.clickAndFllField('DSITREPLDOC', descricao);
		geral.selectNative('IDENTRSAIDOP', es);
		geral.searchAndClickGridField('CDSERIE', serie, 'DSSERIEENTR');
		geral.searchAndClickGridField('NMTIPOOPER', tipoOperacao, 'NMTIPOOPER');
	};

	this.editarDocumentoGerado = (serie, descricao) => {
		geral.clickLimparAutoComplete('CDSERIE');
		geral.searchAndClickGridField('CDSERIE', serie, 'DSSERIEENTR');
		geral.fillField('DSITREPLDOC', descricao);
	};

	this.editar = (descricao, atualizaAutomaticamente) => {
		geral.fillField('DSREPLICDOC', descricao);
		geral.selectNative('IDREPLAUTONF', atualizaAutomaticamente);
	};
}

module.exports = new ReplicaoDeDocumentos();
